ArrayList<Portal> portals = new ArrayList<Portal>();

class Portal {
  float x, y;
  float r = 1;
  float life = random(30, 500);
  
  Portal(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void tick() {
    life--;
    
    stroke(abs(noise(this.x/99, this.y/99))*255, 70, 255);
    point(this.x, this.y);
    for (float x = this.x - r/2; x < this.x + r/2; ++x) {
      for (float y = this.y - r/2; y < this.y + r/2; ++y) {
        float w = this.x - x;
        float h = this.y - y;
        if (w*w + h*h == r/2) {
          stroke(abs(noise(x/99, y/99))*255, 70, 255);
          point(x, y);
        }
      }
    }
    r++;
  }
  
}

void setup() {
  size(1000, 1000);
  background(0);
}

void draw() {
  if (mousePressed == true) {
    portals.add(new Portal(mouseX, mouseY));
  }
  for (int i = 0; i < portals.size(); ++i) {
    Portal p = portals.get(i);
    p.tick();
    if (p.life <= 0) {
      portals.remove(i);
    }
  }
  saveFrame("save_####.png");
}